from osv import osv, fields
from tools.translate import _

class customer_ytd_balance(osv.osv):
    _name='res.partner'
    _inherit = 'res.partner'
    _description='Show the YTD balance of customer.'
    _
    def _get_ytd_balance(self,cr,uid,ids,name=None ,args=None,context=None):
        res = {}
        
        for obj in self.browse(cr,uid,ids,context=None):
            today = fields.date.today()
            where_ids = '()'
            fiscal_year = self.pool.get('account.fiscalyear')
            context.update({'company_id' : obj.company_id.id})
            fy_id = fiscal_year.find(cr,uid,dt=today,context=context)
            if fy_id :
                fy_period_ids = self.pool.get('account.period').search(cr,1,[('fiscalyear_id','=',fy_id)],context=context)
                if fy_period_ids :
                    where_ids ='(' +  ','.join(str(a) for a in fy_period_ids) + ')'
            cr.execute("""
                        select sum(credit) - sum(debit) from account_move_line inner join account_journal on account_journal.id = account_move_line.journal_id 
                        and account_journal.type in('bank','cash') and
                        (account_move_line.reconcile_id is not null or reconcile_partial_id is not null) and partner_id = %d and period_id in %s """ %(obj.id,where_ids))
            result = cr.fetchone()
            if result :
                res[obj.id] = result[0] 
            else :
                res[obj.id] = None
        return res
    
        
    _columns={'ytd_balance':fields.function(_get_ytd_balance,string='YTD Balance.',type='float',
                            help= """It shows the Year To Date Balance of a partner.
It returns value that includes 
    - Purchase
    - Purchase Return
    - Sales
    - Sales Return 
for partner's company and current fiscal year."""),
              }
    
    
customer_ytd_balance()